Play = function (game) {

};

Play.prototype = {

    preload: function () {
        data.boxBullet = null;
        data.boxNote = null;
    },
    create: function () {

        //efeitos sonoros
        this.fxBala = game.add.audio('fx-bala');
        this.fxErro = game.add.audio('fx-erro');
        this.fxExplosao = game.add.audio('fx-explosao');
        this.fxExplosao.volume = 0.1;
        this.fx = game.add.audio('fx-botao');
        
        data.pause = true;




        //calcula velocidade
        data.velocidade = velocidades[data.dificuldade];

        //zera placar
        placar.acertos = 0;
        placar.erros = 0;
        placar.rendimento = 0;

        //cria a tela de jogo
        this.criatela();

        //configurar barra de tempo
        this.tick = this.timer.width / duracoes[data.duracao];
        game.time.events.loop(Phaser.Timer.SECOND, this.counterTime, this);

        //desenvolvimento
        /*
        setTimeout(function () {
            data.pause = true;
            if (data.boxBullet !== null) {
                data.boxBullet.destroy();

            }
            if (data.boxNote !== null) {
                data.boxNote.destroy();
            }
            setTimeout(function () {
                game.state.start('Result');
            }, 2000);

        }, duracoes[data.duracao] * 1000);*/


        setTimeout(function () {
            data.pause = false;
        }, 2000)
    },
    //atualiza barra de tempo
    counterTime: function () {
        this.timer.x -= this.tick;
        if(this.timer.x + this.timer.width <= 0){
            setTimeout(function () {               
                game.state.start('Result');
            }, 2);
        }
    },
    update: function () {
        if (data.pause) {
            return;
        }
        this.moveNotas();
        this.moveBullets();
        this.lancaNota();

    },
    criatela: function () {

        
        //adiciona banner
        this.banner = game.add.sprite(0,0, 'banner-jogo');
        
        //adiciona placar
        this.certas = game.add.bitmapText(577, 30, 'font-branca', '0', 64);
        this.erradas = game.add.bitmapText(962, 30, 'font-branca', '0', 64);
        

        //adiciona barra timer
        this.timer = game.add.sprite(0, 0, 'timer');



        //adiciona pauta
        this.pauta = game.add.sprite(game.world.centerX, game.world.centerY, 'pauta');
        this.pauta.anchor.setTo(0.5, 0.5);

        //adiciona clave
        this.clave = game.add.sprite(10, game.world.centerY - 91, 'claves');
        this.clave.frame = data.clave;


        //adiciona teclas
        this.adicionaTeclas();

        //botao seta
        this.btnSeta = game.add.button(1190, 60, 'btn-botoes', this.clickSeta, this, 5, 5, 11);
        this.btnSeta.anchor.setTo(0.5, 0.5);
        

    },
    clickSeta: function () {
        this.fx.play();
        game.state.start('Menu');
    },
    teclaClick: function (e) {
        if (data.boxNote == null) {
            return;
        }
        if (data.boxNote.note != e.note) {
            placar.erros += 1;
            this.erradas.setText(placar.erros);            
            this.fxErro.play();
            return;
        }
        //adiciona bala
        if (data.boxBullet == null) {
            data.boxBullet = new Bullet();
            data.boxBullet.set(e.note);
            data.boxBullet.setX(e.x);
            data.boxBullet.setY(game.world.height - 154);
            this.fxBala.play();

        }
    },
    
    moveNotas: function () {
        if (data.boxNote == null) {
            return;
        }
        var x = data.boxNote.x + data.boxNote.vx;
        if (x < 0) {
            data.boxNote.destroy();
            data.boxNote = null;
            if (data.boxBullet != null) {
                data.boxBullet.destroy();
            }

            return;
        }
        data.boxNote.setX(x);

    },
    moveBullets: function () {

        //movimenta só com bullet
        if (data.boxNote == null && data.boxBullet != null) {
            data.boxBullet.setY(data.boxBullety - data.boxBullet.vy);
        }

        //movimenta com ambos
        if (data.boxBullet !== null && data.boxNote !== null) {

            if (data.boxBullet.x < data.boxNote.x) {
                data.boxBullet.setX(data.boxBullet.x + data.boxBullet.vx);
            }
            if (data.boxBullet.x > data.boxNote.x) {
                data.boxBullet.setX(data.boxBullet.x - data.boxBullet.vx);
            }
            if (data.boxBullet.y < data.boxNote.y) {
                data.boxBullet.setY(data.boxBullet.y + data.boxBullet.vy);
            }
            if (data.boxBullet.y > data.boxNote.y) {
                data.boxBullet.setY(data.boxBullet.y - data.boxBullet.vy);
            }

        }
        //destroy
        if (data.boxBullet !== null) {
            if (data.boxBullet.x <= 0 || data.boxBullet.y <= 0) {
                data.boxBullet.destroy();
                data.boxNote.destroy();
            }
        }

        //explode

        if (data.boxBullet !== null && data.boxNote !== null) {
            var a = data.boxBullet.x <= data.boxNote.x + 35 && data.boxBullet.x >= data.boxNote.x - 35;
            var b = data.boxBullet.y <= data.boxNote.y + 35 && data.boxBullet.y >= data.boxNote.y - 35;
            if (a && b) {
                placar.acertos += 1;
                this.certas.setText(placar.acertos);
                
                this.criaExplosao(data.boxNote.x, data.boxNote.y);
                this.fxExplosao.play();
                data.boxBullet.destroy();
                data.boxNote.destroy();

            }
        }



    },
    lancaNota: function () {


        if (data.tessitura == 0) {
            var a = 8;//8
            var b = 9;//9
        } else if (data.tessitura == 1) {
            var a = 6;
            var b = 13;
        } else if(data.tessitura == 2){
            var a = 4;
            var b = 17;
        } else if (data.tessitura == 3) {
            var a = 0;
            var b = 25;
        }


        if (data.boxNote == null) {
            data.boxNote = new Figura();
            data.boxNote.set(Math.floor((Math.random() * b) + a));
        }


    },
    atualizaPlacar: function () {
        this.erradas.setText(placar.erros);
    },
    adicionaTeclas: function () {
        //adiciona teclas
        this.C = game.add.button(105, game.world.height - 154, 'teclas', this.teclaClick, this, 0, 0, 7);
        this.D = game.add.button(262, game.world.height - 154, 'teclas', this.teclaClick, this, 1, 1, 8);
        this.E = game.add.button(419, game.world.height - 154, 'teclas', this.teclaClick, this, 2, 2, 9);
        this.F = game.add.button(577, game.world.height - 154, 'teclas', this.teclaClick, this, 3, 3, 10);
        this.G = game.add.button(739, game.world.height - 154, 'teclas', this.teclaClick, this, 4, 4, 11);
        this.A = game.add.button(895, game.world.height - 154, 'teclas', this.teclaClick, this, 5, 5, 12);
        this.B = game.add.button(1054, game.world.height - 154, 'teclas', this.teclaClick, this, 6, 6, 13);
        this.C.note = 'c';
        this.D.note = 'd';
        this.E.note = 'e';
        this.F.note = 'f';
        this.G.note = 'g';
        this.A.note = 'a';
        this.B.note = 'b';

        this.C.x = 105;
        this.D.x = 262;
        this.E.x = 419;
        this.F.x = 577;
        this.G.x = 739;
        this.A.x = 895;
        this.B.x = 1054;

    },
    criaExplosao: function (x, y) {
        this.explosao = game.add.sprite(x, y, 'explosao');
        this.explosao.anchor.setTo(0.5, 0.5);
        this.explosao.animations.add('explode');
        this.explosao.play('explode', 40, false);
    }
};